---
title: console
slug: Web/API/Console
tags:
  - API
  - Debugging
  - Interface
  - Reference
  - console
  - web console
---
<p>{{APIRef("Console API")}}</p>

<p>The <strong><code>console</code></strong> object provides access to the browser's debugging console (e.g. the <a href="/en-US/docs/Tools/Web_Console">Web Console</a> in Firefox). The specifics of how it works varies from browser to browser, but there is a <em>de facto</em> set of features that are typically provided.</p>

<p>The <code>console</code> object can be accessed from any global object. {{domxref("Window")}} on browsing scopes and {{domxref("WorkerGlobalScope")}} as specific variants in workers via the property console. It's exposed as {{domxref("Window.console")}}, and can be referenced as <code>console</code>. For example:</p>

<pre class="brush: js notranslate">console.log("Failed to open the specified link")</pre>

<p>This page documents the {{anch("Methods")}} available on the <code>console</code> object and gives a few {{anch("Usage")}} examples.</p>

<p>{{AvailableInWorkers}}</p>

<div class="notecard note">
<p><strong>Note</strong>: The actual <code>console</code> interface is defined as all lower case (i.e. not <code>Console</code>), for historical reasons.</p>
</div>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("console.assert()")}}</dt>
 <dd>Log a message and stack trace to console if the first argument is <code>false</code>.</dd>
 <dt>{{domxref("console.clear()")}}</dt>
 <dd>Clear the console.</dd>
 <dt>{{domxref("console.count()")}}</dt>
 <dd>Log the number of times this line has been called with the given label.</dd>
 <dt>{{domxref("console.countReset()")}}</dt>
 <dd>Resets the value of the counter with the given label.</dd>
 <dt>{{domxref("console.debug()")}}</dt>
 <dd>Outputs a message to the console with the log level <code>debug</code>.</dd>
 <dt>{{domxref("console.dir()")}}</dt>
 <dd>Displays an interactive listing of the properties of a specified JavaScript object. This listing lets you use disclosure triangles to examine the contents of child objects.</dd>
 <dt>{{domxref("console.dirxml()")}}</dt>
 <dd>Displays an XML/HTML Element representation of the specified object if possible or the JavaScript Object view if it is not possible.</dd>
 <dt>{{domxref("console.error()")}}</dt>
 <dd>Outputs an error message. You may use <a href="/en-US/docs/Web/API/console#Using_string_substitutions">string substitution</a> and additional arguments with this method.</dd>
 <dt>{{domxref("console.exception()")}} {{Non-standard_inline}} {{deprecated_inline}}</dt>
 <dd>An alias for <code>error()</code>.</dd>
 <dt>{{domxref("console.group()")}}</dt>
 <dd>Creates a new inline <a href="/en-US/docs/Web/API/console#Using_groups_in_the_console">group</a>, indenting all following output by another level. To move back out a level, call <code>groupEnd()</code>.</dd>
 <dt>{{domxref("console.groupCollapsed()")}}</dt>
 <dd>Creates a new inline <a href="/en-US/docs/Web/API/console#Using_groups_in_the_console">group</a>, indenting all following output by another level. However, unlike <code>group()</code> this starts with the inline group collapsed requiring the use of a disclosure button to expand it. To move back out a level, call <code>groupEnd()</code>.</dd>
 <dt>{{domxref("console.groupEnd()")}}</dt>
 <dd>Exits the current inline <a href="/en-US/docs/Web/API/console#Using_groups_in_the_console">group</a>.</dd>
 <dt>{{domxref("console.info()")}}</dt>
 <dd>Informative logging of information. You may use <a href="/en-US/docs/Web/API/console#Using_string_substitutions">string substitution</a> and additional arguments with this method.</dd>
 <dt>{{domxref("console.log()")}}</dt>
 <dd>For general output of logging information. You may use <a href="/en-US/docs/Web/API/console#Using_string_substitutions">string substitution</a> and additional arguments with this method.</dd>
 <dt>{{domxref("console.profile()")}} {{Non-standard_inline}}</dt>
 <dd>Starts the browser's built-in profiler (for example, the <a href="/en-US/docs/Tools/Performance">Firefox performance tool</a>). You can specify an optional name for the profile.</dd>
 <dt>{{domxref("console.profileEnd()")}} {{Non-standard_inline}}</dt>
 <dd>Stops the profiler. You can see the resulting profile in the browser's performance tool (for example, the <a href="/en-US/docs/Tools/Performance">Firefox performance tool</a>).</dd>
 <dt>{{domxref("console.table()")}}</dt>
 <dd>Displays tabular data as a table.</dd>
 <dt>{{domxref("console.time()")}}</dt>
 <dd>Starts a <a href="/en-US/docs/Web/API/console#Timers">timer</a> with a name specified as an input parameter. Up to 10,000 simultaneous timers can run on a given page.</dd>
 <dt>{{domxref("console.timeEnd()")}}</dt>
 <dd>Stops the specified <a href="/en-US/docs/Web/API/console#Timers">timer</a> and logs the elapsed time in seconds since it started.</dd>
 <dt>{{domxref("console.timeLog()")}}</dt>
 <dd>Logs the value of the specified <a href="/en-US/docs/Web/API/console#Timers">timer</a> to the console.</dd>
 <dt>{{domxref("console.timeStamp()")}} {{Non-standard_inline}}</dt>
 <dd>Adds a marker to the browser's <a href="https://developer.chrome.com/devtools/docs/timeline">Timeline</a> or <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a> tool.</dd>
 <dt>{{domxref("console.trace()")}}</dt>
 <dd>Outputs a <a href="/en-US/docs/Web/API/console#Stack_traces">stack trace</a>.</dd>
 <dt>{{domxref("console.warn()")}}</dt>
 <dd>Outputs a warning message. You may use <a href="/en-US/docs/Web/API/console#Using_string_substitutions">string substitution</a> and additional arguments with this method.</dd>
</dl>

<h2 id="Usage">Examples</h2>

<h3 id="Outputting_text_to_the_console">Outputting text to the console</h3>

<p>The most frequently-used feature of the console is logging of text and other data. There are four categories of output you can generate, using the {{domxref("console.log()")}}, {{domxref("console.info()")}}, {{domxref("console.warn()")}}, and {{domxref("console.error()")}} methods respectively. Each of these results in output styled differently in the log, and you can use the filtering controls provided by your browser to only view the kinds of output that interest you.</p>

<p>There are two ways to use each of the output methods; you can pass in a list of objects whose string representations get concatenated into one string, then output to the console, or you can pass in a string containing zero or more substitution strings followed by a list of objects to replace them.</p>

<h4 id="Outputting_a_single_object">Outputting a single object</h4>

<p>The simplest way to use the logging methods is to output a single object:</p>

<pre class="brush: js notranslate">var someObject = { str: "Some text", id: 5 };
console.log(someObject);
</pre>

<p>The output looks something like this:</p>

<pre class="notranslate">[09:27:13.475] ({str:"Some text", id:5})</pre>

<h4 id="Outputting_multiple_objects">Outputting multiple objects</h4>

<p>You can also output multiple objects by listing them when calling the logging method, like this:</p>

<pre class="brush: js notranslate">var car = "Dodge Charger";
var someObject = { str: "Some text", id: 5 };
console.info("My first car was a", car, ". The object is:", someObject);</pre>

<p>This output will look like this:</p>

<pre class="notranslate">[09:28:22.711] My first car was a Dodge Charger . The object is: ({str:"Some text", id:5})
</pre>

<h4 id="Using_string_substitutions">Using string substitutions</h4>

<p>When passing a string to one of the <code>console</code> object's methods that accepts a string (such as <code>log()</code>), you may use these substitution strings:</p>

<dl>
 <dt><code>%o</code> or <code>%O</code></dt>
 <dd>Outputs a JavaScript object. Clicking the object name opens more information about it in the inspector.</dd>
 <dt><code>%d</code> or <code>%i</code></dt>
 <dd>Outputs an integer. Number formatting is supported, for example  <code>console.log("Foo %.2d", 1.1)</code> will output the number as two significant figures with a leading 0: <code>Foo 01</code></dd>
 <dt><code>%s</code></dt>
 <dd>Outputs a string.</dd>
 <dt><code>%f</code></dt>
 <dd>Outputs a floating-point value. Formatting is supported, for example  <code>console.log("Foo %.2f", 1.1)</code> will output the number to 2 decimal places: <code>Foo 1.10</code></dd>
</dl>

<div class="note">
<p><strong>Note</strong>: Precision formatting doesn't work in Chrome</p>
</div>

<p>Each of these pulls the next argument after the format string off the parameter list. For example:</p>

<pre class="notranslate">for (var i=0; i&lt;5; i++) {
  console.log("Hello, %s. You've called me %d times.", "Bob", i+1);
}
</pre>

<p>The output looks like this:</p>

<pre class="notranslate">[13:14:13.481] Hello, Bob. You've called me 1 times.
[13:14:13.483] Hello, Bob. You've called me 2 times.
[13:14:13.485] Hello, Bob. You've called me 3 times.
[13:14:13.487] Hello, Bob. You've called me 4 times.
[13:14:13.488] Hello, Bob. You've called me 5 times.
</pre>

<h4 id="Styling_console_output">Styling console output</h4>

<p>You can use the <code>%c</code> directive to apply a CSS style to console output:</p>

<pre class="brush: js notranslate">console.log("This is %cMy stylish message", "color: yellow; font-style: italic; background-color: blue;padding: 2px");</pre>

<p>The text before the directive will not be affected, but the text after the directive will be styled using the CSS declarations in the parameter.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12527/CSS-styling.png" style="display: block; margin: 0 auto;"></p>

<p>The properties usable along with the <code>%c</code> syntax are as follows (at least, in Firefox — they may differ in other browsers):</p>

<ul>
 <li>{{cssxref("background")}} and its longhand equivalents.</li>
 <li>{{cssxref("border")}} and its longhand equivalents</li>
 <li>{{cssxref("border-radius")}}</li>
 <li>{{cssxref("box-decoration-break")}}</li>
 <li>{{cssxref("box-shadow")}}</li>
 <li>{{cssxref("clear")}} and {{cssxref("float")}}</li>
 <li>{{cssxref("color")}}</li>
 <li>{{cssxref("cursor")}}</li>
 <li>{{cssxref("display")}}</li>
 <li>{{cssxref("font")}} and its longhand equivalents</li>
 <li>{{cssxref("line-height")}}</li>
 <li>{{cssxref("margin")}}</li>
 <li>{{cssxref("outline")}} and its longhand equivalents</li>
 <li>{{cssxref("padding")}}</li>
 <li><code>text-*</code> properties such as {{cssxref("text-transform")}}</li>
 <li>{{cssxref("white-space")}}</li>
 <li>{{cssxref("word-spacing")}} and {{cssxref("word-break")}}</li>
 <li>{{cssxref("writing-mode")}}</li>
</ul>

<div class="notecard note">
<p><strong>Note</strong>: The console message behaves like an inline element by default. To see the effects of <code>padding</code>, <code>margin</code>, etc. you should set it to for example <code>display: inline-block</code>.</p>
</div>

<h3 id="Using_groups_in_the_console">Using groups in the console</h3>

<p>You can use nested groups to help organize your output by visually combining related material. To create a new nested block, call <code>console.group()</code>. The <code>console.groupCollapsed()</code> method is similar but creates the new block collapsed, requiring the use of a disclosure button to open it for reading.</p>

<p>To exit the current group, call <code>console.groupEnd()</code>. For example, given this code:</p>

<pre class="brush: js notranslate">console.log("This is the outer level");
console.group("First group");
console.log("In the first group");
console.group("Second group");
console.log("In the second group");
console.warn("Still in the second group");
console.groupEnd();
console.log("Back to the first group");
console.groupEnd();
console.debug("Back to the outer level");
</pre>

<p>The output looks like this:</p>

<p><img alt="Demo of nested groups in Firefox console" src="https://mdn.mozillademos.org/files/16911/console_groups_demo.png" style="height: 169px; width: 236px;"></p>

<h3 id="Timers">Timers</h3>

<p>You can start a timer to calculate the duration of a specific operation. To start one, call the <code>console.time</code><code>()</code> method, giving it a name as the only parameter. To stop the timer, and to get the elapsed time in milliseconds, just call the <code>console.timeEnd()</code> method, again passing the timer's name as the parameter. Up to 10,000 timers can run simultaneously on a given page.</p>

<p>For example, given this code:</p>

<pre class="brush: js notranslate">console.time("answer time");
alert("Click to continue");
console.timeLog("answer time");
alert("Do a bunch of other stuff...");
console.timeEnd("answer time");
</pre>

<p>Will log the time needed by the user to dismiss the alert box, log the time to the console, wait for the user to dismiss the second alert, and then log the ending time to the console:</p>

<p><img alt="timerresult.png" class="default internal" src="https://mdn.mozillademos.org/files/16113/console-timeLog.png" style="border: 1px solid black; height: 102px; margin: 0 auto; width: 318px;"></p>

<p>Notice that the timer's name is displayed both when the timer is started and when it's stopped.</p>

<p class="note"><strong>Note:</strong> It's important to note that if you're using this to log the timing for network traffic, the timer will report the total time for the transaction, while the time listed in the network panel is just the amount of time required for the header. If you have response body logging enabled, the time listed for the response header and body combined should match what you see in the console output.</p>

<h3 id="Stack_traces">Stack traces</h3>

<p>The console object also supports outputting a stack trace; this will show you the call path taken to reach the point at which you call {{domxref("console.trace()")}}. Given code like this:</p>

<pre class="brush: js notranslate">function foo() {
  function bar() {
    console.trace();
  }
  bar();
}

foo();
</pre>

<p>The output in the console looks something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/7167/api-trace2.png" style="display: block; margin-left: auto; margin-right: auto;"></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Console API')}}</td>
   <td>{{Spec2('Console API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Console")}}</p>

<h2 id="Notes">Notes</h2>

<ul>
 <li>At least in Firefox, if a page defines a <code>console</code> object, that object overrides the one built into Firefox.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Tools" title="Tools">Firefox Developer Tools</a></li>
 <li><a href="/en-US/docs/Tools/Web_Console" title="Web Console">Web Console</a> — how the Web Console in Firefox handles console API calls</li>
 <li><a href="/en-US/docs/Tools/Remote_Debugging">Remote Debugging</a> — how to see console output when the debugging target is a mobile device</li>
</ul>

<h3 id="Other_implementations">Other implementations</h3>

<ul>
 <li><a href="https://developers.google.com/chrome-developer-tools/docs/console-api">Google Chrome DevTools</a></li>
 <li><a href="https://docs.microsoft.com/en-us/microsoft-edge/devtools-guide/console/console-api">Microsoft Edge DevTools</a></li>
 <li><a href="https://developer.apple.com/library/safari/documentation/AppleApplications/Conceptual/Safari_Developer_Guide/Console/Console.html">Safari Web Inspector</a></li>
</ul>
